var WebViewJavascriptBridge = window.WebViewJavascriptBridge;
var WVJBCallbacks = window.WVJBCallbacks;
function isAndroid() {
  var u = navigator.userAgent;
  return u.indexOf('Android') > -1 || u.indexOf('Adr') > -1;
}
function isIOS() {
  var u = navigator.userAgent;
  return !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/);
}
function isFengmang() {
  var u = navigator.userAgent;
  return u.indexOf('fmapp') > -1 || u.indexOf('fmapp') > -1;
}
// iOS装载bridge
function setupWebViewJavascriptBridgeIOS(callback) {
  if (WebViewJavascriptBridge) {
    return callback(WebViewJavascriptBridge);
  }
  if (WVJBCallbacks) {
    return WVJBCallbacks.push(callback);
  }
  WVJBCallbacks = [callback];
  var WVJBIframe = document.createElement('iframe');
  WVJBIframe.style.display = 'none';
  WVJBIframe.src = 'https://__bridge_loaded__';
  document.documentElement.appendChild(WVJBIframe);
  setTimeout(function () {
    document.documentElement.removeChild(WVJBIframe);
  }, 0);
}
// android装载bridge
function setupWebViewJavascriptBridgeAndroid(callback) {
  console.log('WebViewJavascriptBridge');
  console.log(WebViewJavascriptBridge);
  if (WebViewJavascriptBridge) {
    return new Promise(function (resolve, reject) {
      resolve(WebViewJavascriptBridge);
    }).then(function (res) {
      callback(res);
    });
  } else {
    return new Promise(function (resolve, reject) {
      document.addEventListener('WebViewJavascriptBridgeReady', function () {
        console.log('监听WebViewJavascriptBridgeReady得到的WebViewJavascriptBridge');
        try {
          WebViewJavascriptBridge = WebViewJavascriptBridge;
        } catch (error) {}
        resolve(WebViewJavascriptBridge);
      }, false);
    }).then(function (res) {
      callback(res);
    });
  }
}
// 区分iOS和android的装载方式
var setupWebViewJavascriptBridge = /*#__PURE__*/isAndroid() ? setupWebViewJavascriptBridgeAndroid : setupWebViewJavascriptBridgeIOS;
// 调用方法
function callMethod(method, args) {
  // console.log(`h5调用方法名${method}\n参数:${JSON.stringify(args)}`);
  return new Promise(function (resolve, reject) {
    setupWebViewJavascriptBridge(function (bridge) {
      bridge.callHandler(method, JSON.stringify(args), function responseCallback(responseData) {
        try {
          resolve(JSON.parse(responseData));
        } catch (error) {
        }
      });
    });
  });
}
// 注册方法
function registerMethod(name, func) {
  // console.log(`h5注册方法名${name}`);
  setupWebViewJavascriptBridge(function (bridge) {
    bridge.registerHandler(name, func);
  });
}
// register Demo 返回值需要callback
var fmBridge = {
  call: callMethod,
  register: registerMethod,
  init: function init(params) {
    return callMethod('initFM', params = null);
  },
  getAppInfo: function getAppInfo() {
    if (isIOS()) {
      return new Promise(function (resolve, reject) {
        setupWebViewJavascriptBridge(function (bridge) {
          bridge.callHandler('getAppInfo', '', function responseCallback(responseData) {
            try {
              resolve(responseData);
            } catch (error) {
            }
          });
        });
      });
    }
    return callMethod('getAppInfo');
  },
  getAppBaseInfo: function getAppBaseInfo() {
    return callMethod('getAppBaseInfo');
  },
  updateVersion: function updateVersion() {
    return callMethod('updateVersion');
  },
  toggleMenuButton: function toggleMenuButton(params) {
    // 切换菜单按钮
    return callMethod('toggleMenuButton', params);
  },
  getUserInfo: function getUserInfo() {
    return callMethod('getUserInfo');
  },
  /**
   * 即将废弃
   */
  getShareData: function getShareData(shareData) {
    if (shareData === void 0) {
      shareData = {};
    }
    registerMethod('getShareData', function (_, callback) {
      // console.log('getShareData:', JSON.stringify(shareData));
      callback(JSON.stringify(shareData));
    });
  },
  updateUserInfo: function updateUserInfo(func) {
    registerMethod('updateUserInfo', function (data, callback) {
      console.log('更新用户信息', data);
      func(JSON.parse(data));
    });
  },
  openUI: function openUI(args) {
    return callMethod('openUI', args);
  },
  showMenuItems: function showMenuItems(params) {
    registerMethod('showMenuItems', function (_, callback) {
      callback(JSON.stringify(params));
    });
  },
  updateNetwork: function updateNetwork(func) {
    console.log('updateNetwork');
    registerMethod('updateNetwork', function (data, callback) {
      console.log('更新用户网络', data);
      func(JSON.parse(data));
    });
  },
  copy: function copy(
  /**
   *链接地址
   */
  url) {
    registerMethod('copy', function (data, callback) {
      console.log('copy', url);
      try {
        callback(JSON.stringify({
          url: url || 'https://ls.mangguonews.com/mgndload'
        }));
      } catch (error) {
        console.log(error);
      }
    });
  },
  share: function share(params) {
    registerMethod('share', function (data, callback) {
      console.log('share', params);
      try {
        callback(JSON.stringify(params));
      } catch (error) {
        console.log(error);
      }
    });
  },
  like: function like(params) {
    console.log('like', params);
    registerMethod('like', function (data, callback) {
      console.log('like', params);
      try {
        callback(JSON.stringify(params));
      } catch (error) {
        console.log(error);
      }
    });
  },
  collect: function collect(params) {
    registerMethod('collect', function (data, callback) {
      console.log('collect', params);
      try {
        callback(JSON.stringify(params));
      } catch (error) {
        console.log(error);
      }
    });
  },
  popToUI: function popToUI(params) {
    return callMethod('popToUI', params);
  },
  openURL: function openURL(params) {
    return callMethod('openURL', params);
  },
  cancelAccount: function cancelAccount(params) {
    return callMethod('cancelAccount', params);
  },
  accountConflict: function accountConflict(params) {
    return callMethod('accountConflict', params);
  },
  toggleBackButton: function toggleBackButton(params) {
    return callMethod('toggleBackButton', params);
  },
  popGesture: function popGesture(params) {
    return callMethod('popGesture', params);
  },
  isFengmang: /*#__PURE__*/isFengmang()
};
window.fmBridge = fmBridge;

export default fmBridge;
//# sourceMappingURL=fm-bridge1.esm.js.map
